Index: src/hugo/list_graph.h
===================================================================
--- src/hugo/list_graph.h	(revision 722)
+++ src/hugo/list_graph.h	(revision 774)
@@ -132,10 +132,4 @@
     Node head(Edge e) const { return edges[e.n].head; }
 
-    Node aNode(OutEdgeIt e) const { return edges[e.n].tail; }
-    Node aNode(InEdgeIt e) const { return edges[e.n].head; }
-
-    Node bNode(OutEdgeIt e) const { return edges[e.n].head; }
-    Node bNode(InEdgeIt e) const { return edges[e.n].tail; }
-
     NodeIt& first(NodeIt& v) const { 
       v=NodeIt(*this); return v; }
@@ -147,41 +141,4 @@
       e=InEdgeIt(*this,v); return e; }
 
-//     template< typename It >
-//     It first() const { It e; first(e); return e; }
-
-//     template< typename It >
-//     It first(Node v) const { It e; first(e,v); return e; }
-
-    static bool valid(Edge e) { return e.n!=-1; }
-    static bool valid(Node n) { return n.n!=-1; }
-    
-    static void setInvalid(Edge &e) { e.n=-1; }
-    static void setInvalid(Node &n) { n.n=-1; }
-    
-    template <typename It> static It getNext(It it)
-    { It tmp(it); return next(tmp); }
-
-    NodeIt& next(NodeIt& it) const { 
-      it.n=nodes[it.n].next; 
-      return it; 
-    }
-    OutEdgeIt& next(OutEdgeIt& it) const
-    { it.n=edges[it.n].next_out; return it; }
-    InEdgeIt& next(InEdgeIt& it) const
-    { it.n=edges[it.n].next_in; return it; }
-    EdgeIt& next(EdgeIt& it) const {
-      if(edges[it.n].next_in!=-1) { 
-	it.n=edges[it.n].next_in;
-      }
-      else {
-	int n;
-	for(n=nodes[edges[it.n].head].next;
-	    n!=-1 && nodes[n].first_in == -1;
-	    n = nodes[n].next) ;
-	it.n = (n==-1)?-1:nodes[n].first_in;
-      }
-      return it;
-    }
-
     static int id(Node v) { return v.n; }
     static int id(Edge e) { return e.n; }
@@ -251,5 +208,21 @@
       return e;
     }
-
+    
+    /// Finds an edge between two nodes.
+
+    /// Finds an edge from node \c u to node \c v.
+    ///
+    /// If \c prev is \ref INVALID (this is the default value), then
+    /// It finds the first edge from \c u to \c v. Otherwise it looks for
+    /// the next edge from \c u to \c v after \c prev.
+    /// \return The found edge or INVALID if there is no such an edge.
+    Edge findEdge(Node u,Node v, Edge prev = INVALID) 
+    {
+      int e = (prev.n==-1)? nodes[u.n].first_out : edges[prev.n].next_out;
+      while(e!=-1 && edges[e].tail!=v.n) e = edges[e].next_out;
+      prev.n=e;
+      return prev;
+    }
+    
   private:
     void eraseEdge(int n) {
@@ -325,14 +298,23 @@
       bool operator!=(const Node i) const {return n!=i.n;}
       bool operator<(const Node i) const {return n<i.n;}
+      //      ///Validity check
+      //      operator bool() { return n!=-1; }
     };
     
     class NodeIt : public Node {
+      const ListGraph *G;
       friend class ListGraph;
     public:
       NodeIt() : Node() { }
       NodeIt(Invalid i) : Node(i) { }
-      NodeIt(const ListGraph& G) : Node(G.first_node) { }
+      NodeIt(const ListGraph& _G) : Node(_G.first_node), G(&_G) { }
       ///\todo Undocumented conversion Node -\> NodeIt.
-      NodeIt(const ListGraph& G, const Node &n) : Node(n) { }
+      NodeIt(const ListGraph& _G,Node n) : Node(n), G(&_G) { }
+      NodeIt &operator++() {
+	n=G->nodes[n].next; 
+	return *this; 
+      }
+      //      ///Validity check
+      //      operator bool() { return Node::operator bool(); }      
     };
 
@@ -365,39 +347,67 @@
       ///make class \c SymListGraph::SymEdgeMap friend of Edge
       int &idref() {return n;}
-      const int &idref() const {return n;}
-    };
+      const int &idref() const {return n;} 
+      //      ///Validity check
+      //      operator bool() { return n!=-1; }
+   };
     
     class EdgeIt : public Edge {
+      const ListGraph *G;
       friend class ListGraph;
     public:
-      EdgeIt(const ListGraph& G) : Edge() {
+      EdgeIt(const ListGraph& _G) : Edge(), G(&_G) {
       	int m;
-	for(m=G.first_node;
-	    m!=-1 && G.nodes[m].first_in == -1; m = G.nodes[m].next);
-	n = (m==-1)?-1:G.nodes[m].first_in;
+	for(m=_G.first_node;
+	    m!=-1 && _G.nodes[m].first_in == -1; m = _G.nodes[m].next);
+	n = (m==-1)?-1:_G.nodes[m].first_in;
       }
       EdgeIt (Invalid i) : Edge(i) { }
+      EdgeIt(const ListGraph& _G, Edge e) : Edge(e), G(&_G) { }
       EdgeIt() : Edge() { }
       ///\bug This is a workaround until somebody tells me how to
       ///make class \c SymListGraph::SymEdgeMap friend of Edge
       int &idref() {return n;}
+      EdgeIt &operator++() {
+	if(G->edges[n].next_in!=-1) n=G->edges[n].next_in;
+	else {
+	  int nn;
+	  for(nn=G->nodes[G->edges[n].head].next;
+	      nn!=-1 && G->nodes[nn].first_in == -1;
+	      nn = G->nodes[nn].next) ;
+	  n = (nn==-1)?-1:G->nodes[nn].first_in;
+	}
+	return *this;
+      }
+      //      ///Validity check
+      //      operator bool() { return Edge::operator bool(); }      
     };
     
     class OutEdgeIt : public Edge {
+      const ListGraph *G;
       friend class ListGraph;
     public: 
       OutEdgeIt() : Edge() { }
+      OutEdgeIt(const ListGraph& _G, Edge e) : Edge(e), G(&_G) { }
       OutEdgeIt (Invalid i) : Edge(i) { }
 
-      OutEdgeIt(const ListGraph& G,const Node v)
-	: Edge(G.nodes[v.n].first_out) {}
+      OutEdgeIt(const ListGraph& _G,const Node v)
+	: Edge(_G.nodes[v.n].first_out), G(&_G) {}
+      OutEdgeIt &operator++() { n=G->edges[n].next_out; return *this; }
+      //      ///Validity check
+      //      operator bool() { return Edge::operator bool(); }      
     };
     
     class InEdgeIt : public Edge {
+      const ListGraph *G;
       friend class ListGraph;
     public: 
       InEdgeIt() : Edge() { }
+      InEdgeIt(const ListGraph& _G, Edge e) : Edge(e), G(&_G) { }
       InEdgeIt (Invalid i) : Edge(i) { }
-      InEdgeIt(const ListGraph& G,Node v) :Edge(G.nodes[v.n].first_in) {}
+      InEdgeIt(const ListGraph& _G,Node v)
+	: Edge(_G.nodes[v.n].first_in), G(&_G) { }
+      InEdgeIt &operator++() { n=G->edges[n].next_in; return *this; }
+      //      ///Validity check
+      //      operator bool() { return Edge::operator bool(); }      
     };
 
@@ -839,10 +849,4 @@
     Node head(Edge e) const { return INVALID; }
 
-    Node aNode(OutEdgeIt e) const { return INVALID; }
-    Node aNode(InEdgeIt e) const { return INVALID; }
-
-    Node bNode(OutEdgeIt e) const { return INVALID; }
-    Node bNode(InEdgeIt e) const { return INVALID; }
-
     NodeIt& first(NodeIt& v) const { 
       v=NodeIt(*this); return v; }
@@ -854,27 +858,4 @@
       e=InEdgeIt(*this,v); return e; }
 
-//     template< typename It >
-//     It first() const { It e; first(e); return e; }
-
-//     template< typename It >
-//     It first(Node v) const { It e; first(e,v); return e; }
-
-    bool valid(Edge e) const { return false; }
-    bool valid(Node n) const { return n.n!=-1; }
-    
-    void setInvalid(Edge &e) { }
-    void setInvalid(Node &n) { n.n=-1; }
-    
-    template <typename It> It getNext(It it) const
-    { It tmp(it); return next(tmp); }
-
-    NodeIt& next(NodeIt& it) const { 
-      it.n=nodes[it.n].next; 
-      return it; 
-    }
-    OutEdgeIt& next(OutEdgeIt& it) const { return it; }
-    InEdgeIt& next(InEdgeIt& it) const { return it; }
-    EdgeIt& next(EdgeIt& it) const { return it; }
-
     int id(Node v) const { return v.n; }
     int id(Edge e) const { return -1; }
@@ -928,4 +909,10 @@
     }
     
+        
+    Edge findEdge(Node u,Node v, Edge prev = INVALID) 
+    {
+      return INVALID;
+    }
+    
     ///\bug Dynamic maps must be updated!
     ///
@@ -956,12 +943,15 @@
     
     class NodeIt : public Node {
+      const NodeSet *G;
       friend class NodeSet;
     public:
       NodeIt() : Node() { }
+      NodeIt(const NodeSet& _G,Node n) : Node(n), G(&_G) { }
       NodeIt(Invalid i) : Node(i) { }
-      NodeIt(const NodeSet& G) : Node(G.first_node) { }
-      ///\todo Undocumented conversion Node -\> NodeIt.
-      NodeIt(const NodeSet& G, const Node &n) : Node(n) { }
-
+      NodeIt(const NodeSet& _G) : Node(_G.first_node), G(&_G) { }
+      NodeIt &operator++() {
+	n=G->nodes[n].next; 
+	return *this; 
+      }
     };
 
@@ -994,4 +984,5 @@
     public:
       EdgeIt(const NodeSet& G) : Edge() { }
+      EdgeIt(const NodeSet&, Edge) : Edge() { }
       EdgeIt (Invalid i) : Edge(i) { }
       EdgeIt() : Edge() { }
@@ -999,4 +990,5 @@
       ///make class \c SymNodeSet::SymEdgeMap friend of Edge
       //      int idref() {return -1;}
+      EdgeIt operator++() { return INVALID; }
     };
     
@@ -1005,6 +997,8 @@
     public: 
       OutEdgeIt() : Edge() { }
+      OutEdgeIt(const NodeSet&, Edge) : Edge() { }
       OutEdgeIt (Invalid i) : Edge(i) { }
       OutEdgeIt(const NodeSet& G,const Node v)	: Edge() {}
+      OutEdgeIt operator++() { return INVALID; }
     };
     
@@ -1013,6 +1007,8 @@
     public: 
       InEdgeIt() : Edge() { }
+      InEdgeIt(const NodeSet&, Edge) : Edge() { }
       InEdgeIt (Invalid i) : Edge(i) { }
       InEdgeIt(const NodeSet& G,Node v) :Edge() {}
+      InEdgeIt operator++() { return INVALID; }
     };
 
@@ -1200,13 +1196,13 @@
     public:
       NodeIt() : NodeGraphType::NodeIt() { }
+      NodeIt(const EdgeSet& _G,Node n) : NodeGraphType::NodeIt(_G.G,n) { }
       NodeIt (Invalid i) : NodeGraphType::NodeIt(i) {}
       NodeIt(const EdgeSet& _G) : NodeGraphType::NodeIt(_G.G) { }
       NodeIt(const typename NodeGraphType::NodeIt &n)
 	: NodeGraphType::NodeIt(n) {}
-      ///\todo Undocumented conversion Node -\> NodeIt.
-      NodeIt(const EdgeSet& _G, const Node &n)
-	: NodeGraphType::NodeIt(_G.G,n) { }
 
       operator Node() { return Node(*this);}
+      NodeIt &operator++()
+      { this->NodeGraphType::NodeIt::operator++(); return *this;} 
     };
 
@@ -1311,10 +1307,4 @@
     Node tail(Edge e) const { return edges[e.n].tail; }
     Node head(Edge e) const { return edges[e.n].head; }
-
-    Node aNode(OutEdgeIt e) const { return edges[e.n].tail; }
-    Node aNode(InEdgeIt e) const { return edges[e.n].head; }
-
-    Node bNode(OutEdgeIt e) const { return edges[e.n].head; }
-    Node bNode(InEdgeIt e) const { return edges[e.n].tail; }
 
     NodeIt& first(NodeIt& v) const { 
@@ -1327,38 +1317,4 @@
       e=InEdgeIt(*this,v); return e; }
 
-//     template< typename It >
-//     It first() const { It e; first(e); return e; }
-
-//     template< typename It >
-//     It first(Node v) const { It e; first(e,v); return e; }
-
-    bool valid(Edge e) const { return e.n!=-1; }
-    bool valid(Node n) const { return G.valid(n); }
-    
-    void setInvalid(Edge &e) { e.n=-1; }
-    void setInvalid(Node &n) { G.setInvalid(n); }
-    
-    template <typename It> It getNext(It it) const
-    { It tmp(it); return next(tmp); }
-
-    NodeIt& next(NodeIt& it) const { G.next(it); return it; }
-    OutEdgeIt& next(OutEdgeIt& it) const
-    { it.n=edges[it.n].next_out; return it; }
-    InEdgeIt& next(InEdgeIt& it) const
-    { it.n=edges[it.n].next_in; return it; }
-    EdgeIt& next(EdgeIt& it) const {
-      if(edges[it.n].next_in!=-1) { 
-	it.n=edges[it.n].next_in;
-      }
-      else {
-	NodeIt n(*this,edges[it.n].head);
-	for(n=next(n);
-	    valid(n) && nodes[n].first_in == -1;
-	    next(n)) ;
-	it.n = (valid(n))?-1:nodes[n].first_in;
-      }
-      return it;
-    }
-
     int id(Edge e) const { return e.n; }
 
@@ -1399,4 +1355,20 @@
     }
 
+    /// Finds an edge between two nodes.
+
+    /// Finds an edge from node \c u to node \c v.
+    ///
+    /// If \c prev is \ref INVALID (this is the default value), then
+    /// It finds the first edge from \c u to \c v. Otherwise it looks for
+    /// the next edge from \c u to \c v after \c prev.
+    /// \return The found edge or INVALID if there is no such an edge.
+    Edge findEdge(Node u,Node v, Edge prev = INVALID) 
+    {
+      int e = (prev.n==-1)? nodes[u].first_out : edges[prev.n].next_out;
+      while(e!=-1 && edges[e].tail!=v) e = edges[e].next_out;
+      prev.n=e;
+      return prev;
+    }
+    
   private:
     void eraseEdge(int n) {
@@ -1461,5 +1433,5 @@
       friend class NodeIt;
     public:
-      ///\bug It shoud be at least protected
+      ///\bug It should be at least protected
       ///
       int n;
@@ -1484,17 +1456,25 @@
       template <typename T> friend class EdgeMap;
     
-      
-    public:
-      EdgeIt(const EdgeSet& G) : Edge() {
+      const EdgeSet *G;
+    public:
+      EdgeIt(const EdgeSet& _G) : Edge(), G(&_G) {
 	//      	typename NodeGraphType::Node m;
         NodeIt m;
-	for(G.first(m);
-	    G.valid(m) && G.nodes[m].first_in == -1;  G.next(m));
-	//AJJAJ! This is a non sense!!!!!!!
-	this->n = G.valid(m)?-1:G.nodes[m].first_in;
-      }
+	for(G->first(m);
+	    m!=INVALID && G->nodes[m].first_in == -1;  ++m);
+	///\bug AJJAJ! This is a non sense!!!!!!!
+	this->n = m!=INVALID?-1:G->nodes[m].first_in;
+      }
+      EdgeIt(const EdgeSet& _G, Edge e) : Edge(e), G(&_G) { }
       EdgeIt (Invalid i) : Edge(i) { }
       EdgeIt() : Edge() { }
-      ///\bug This is a workaround until somebody tells me how to
+      ///.
+      
+      ///\bug UNIMPLEMENTED!!!!!
+      //
+      EdgeIt &operator++() {
+	return *this;
+      }
+       ///\bug This is a workaround until somebody tells me how to
       ///make class \c SymEdgeSet::SymEdgeMap friend of Edge
       int &idref() {return this->n;}
@@ -1502,18 +1482,26 @@
     
     class OutEdgeIt : public Edge {
+      const EdgeSet *G;
       friend class EdgeSet;
     public: 
       OutEdgeIt() : Edge() { }
       OutEdgeIt (Invalid i) : Edge(i) { }
-
-      OutEdgeIt(const EdgeSet& G,const Node v) : Edge(G.nodes[v].first_out) { }
+      OutEdgeIt(const EdgeSet& _G, Edge e) : Edge(e), G(&_G) { }
+
+      OutEdgeIt(const EdgeSet& _G,const Node v) :
+	Edge(_G.nodes[v].first_out), G(&_G) { }
+      OutEdgeIt &operator++() { n=G->edges[n].next_out; return *this; }
     };
     
     class InEdgeIt : public Edge {
+      const EdgeSet *G;
       friend class EdgeSet;
     public: 
       InEdgeIt() : Edge() { }
       InEdgeIt (Invalid i) : Edge(i) { }
-      InEdgeIt(const EdgeSet& G,Node v) :Edge(G.nodes[v].first_in) { }
+      InEdgeIt(const EdgeSet& _G, Edge e) : Edge(e), G(&_G) { }
+      InEdgeIt(const EdgeSet& _G,Node v)
+	: Edge(_G.nodes[v].first_in), G(&_G) { }
+      InEdgeIt &operator++() { n=G->edges[n].next_in; return *this; }
     };
 
@@ -1555,15 +1543,15 @@
 	//FIXME: What if there are empty Id's?
 	//FIXME: Can I use 'this' in a constructor?
-	G->dyn_edge_maps.push_back(this);
+	this->G->dyn_edge_maps.push_back(this);
       }
       EdgeMap(const EdgeSet &_G,const T &t) :
 	DynMapBase<Edge>(_G), container(_G.maxEdgeId(),t)
       {
-	G->dyn_edge_maps.push_back(this);
+	this->G->dyn_edge_maps.push_back(this);
       } 
       EdgeMap(const EdgeMap<T> &m) :
  	DynMapBase<Edge>(*m.G), container(m.container)
       {
- 	G->dyn_edge_maps.push_back(this);
+ 	this->G->dyn_edge_maps.push_back(this);
       }
 
@@ -1573,5 +1561,5 @@
 	DynMapBase<Edge>(*m.G), container(m.container.size())
       {
-	G->dyn_edge_maps.push_back(this);
+	this->G->dyn_edge_maps.push_back(this);
 	typename std::vector<TT>::const_iterator i;
 	for(typename std::vector<TT>::const_iterator i=m.container.begin();
@@ -1582,13 +1570,13 @@
       ~EdgeMap()
       {
-	if(G) {
+	if(this->G) {
 	  typename std::vector<DynMapBase<Edge>* >::iterator i;
-	  for(i=G->dyn_edge_maps.begin();
-	      i!=G->dyn_edge_maps.end() && *i!=this; ++i) ;
+	  for(i=this->G->dyn_edge_maps.begin();
+	      i!=this->G->dyn_edge_maps.end() && *i!=this; ++i) ;
 	  //if(*i==this) G->dyn_edge_maps.erase(i); //Way too slow...
 	  //A better way to do that: (Is this really important?)
 	  if(*i==this) {
-	    *i=G->dyn_edge_maps.back();
-	    G->dyn_edge_maps.pop_back();
+	    *i=this->G->dyn_edge_maps.back();
+	    this->G->dyn_edge_maps.pop_back();
 	  }
 	}
@@ -1603,14 +1591,14 @@
       ///\bug This doesn't work. Why?
       ///      void set(Edge n, T a) { container[n.n]=a; }
-      void set(Edge n, T a) { container[G->id(n)]=a; }
+      void set(Edge n, T a) { container[this->G->id(n)]=a; }
       //T get(Edge n) const { return container[n.n]; }
       typename std::vector<T>::reference
       ///\bug This doesn't work. Why?
       ///      operator[](Edge n) { return container[n.n]; }
-      operator[](Edge n) { return container[G->id(n)]; }
+      operator[](Edge n) { return container[this->G->id(n)]; }
       typename std::vector<T>::const_reference
       ///\bug This doesn't work. Why?
       ///      operator[](Edge n) const { return container[n.n]; }
-      operator[](Edge n) const { return container[G->id(n)]; }
+      operator[](Edge n) const { return container[this->G->id(n)]; }
 
       ///\warning There is no safety check at all!
